import numpy as np

class player:
    #default for most factions
    def __init__(self, fac):
        self.faction = fac
        self.mana1 = 2
        self.mana2 = 2
        self.mana3 = 4
        self.strongh1 = 1
        self.strongh2 = 1
        self.tradep = 4
        self.houses = 8
        #array notation: [house1 moneyinc, house2 ...]
        #                [house1 powerinc, house2 ...]
        self.houses_income = np.array([[3,3,3,2,0,1,0,0],[0,0,0,0,2,0,1,0]])
        self.tp_income = np.array([[2,2,2,2],[2,2,1,1]])
        self.sh1_income = np.array([[0],[2]])
        self.money = 7
        self.moneyinc = 2
        self.powerinc = 0
        self.sailing = 0
        self.bridges = 3
        self.vp = 0
        self.passed = True
        '''
        colorcodes:
        river = 0
        forest = 1
        mountain = 2
        desert = 3
        swamp = 4
        island = 5
        '''
        self.color = 10
        if fac == "fairies":
            self.color = 1
            self.tp_income = np.array([[3,3,3,3],[2,2,1,1]])
            self.sh1_income = np.array([[2],[3]])
            #faction ability
            self.powerinc = 2
        if fac == "druids":
            self.color = 1
            self.tp_income = np.array([[3,3,2,2],[1,1,1,1]])
            self.sh1_income = np.array([[0],[4]])
        if fac == "firesprites":
            self.color = 2
            self.sh1_income = np.array([[0],[4]])
        if fac == "golems":
            self.color = 2
            self.houses_income = np.array([[3,2,2,2,0,1,0,0],[0,0,0,0,2,0,1,0]])
            self.tp_income = np.array([[2,2,2,2],[1,1,1,1]])
            self.sh1_income = np.array([[0],[4]])
        if fac == "sunworshippers":
            self.color = 3
            self.money = 5
        if fac == "sandcats":
            self.color = 3
            self.houses_income = np.array([[3,3,0,2,0,1,0,0],[0,0,0,0,2,0,1,0]])
            self.tp_income = np.array([[2,2,2,3],[2,2,1,1]])
        if fac == "leprechauns":
            self.color = 4
            self.houses_income = np.array([[3,3,3,3,0,2,0,0],[0,0,0,0,3,0,2,0]])
            self.tp_income = np.array([[2,2,3,3],[1,1,2,2]])
            self.sh1_income = np.array([[5],[2]])
        if fac == "inventors":
            self.color = 4
            self.houses_income = np.array([[3,2,2,2,0,1,0,0],[0,0,0,0,2,0,1,0]])
            self.tp_income = np.array([[2,2,1,1],[1,1,1,1]])                                
        if fac == "seadogs":
            self.color = 5

        if fac == "watersprites":
            self.color = 5
            self.houses_income = np.array([[3,3,3,0,0,1,0,0],[0,0,0,0,2,0,1,0]])
            self.tp_income = np.array([[2,3,2,2],[1,1,1,1]])                                
    
    def print_player(self):
        print("money " + str(self.money) + ", mana " + str(self.mana1) + " " + str(self.mana2) + " " + str(self.mana3) +
               ", inc " + str(self.moneyinc) + " " + str(self.powerinc) + 
               ", builds " + str(8-self.houses) + " " + str(4-self.tradep) + " " + str(1-self.strongh1) + " " + str(1-self.strongh2) +
               ", sail " + str(self.sailing) + ", bridges " + str(self.bridges) + ", vp " + str(self.vp) + " - " + self.faction)